
import os,sys
from Bio import SeqIO

#get all the sequence
f = open(sys.argv[1],'r')
records = list(SeqIO.parse(f,'stockholm'))
f.close()

seqoutfile = sys.argv[1].split('_')

mode = '_'.join(seqoutfile[:3]+[seqoutfile[4][:-4]])

#reject the burn in samples. 
seq_cut_num = 10000

fo = open('./NewMH/'+mode + '_SelectedSamples_train.fasta','w')
ftest = open('./NewMH/'+mode+'_SelectedSamples_test.fasta','w')

prev_iter = 1

#equal number of training samples from all pdbs

complex_dir = {}

print len(records)

prev_pdb = ''

for record in records:
    iter_str = record.id.split('_')[-1][3:]
    pdb= record.id.split('_')[0]
    if prev_pdb != pdb: 
       prev_iter = 1
    curr_iter =  eval(iter_str) 
    #print record.id 
    if (curr_iter >= seq_cut_num) and (curr_iter >= prev_iter+10):
       #print pdb, curr_iter
       #check if you are not too close to the earlier accepted sample
       complex_dir.setdefault(pdb,[]).append(record)
       #SeqIO.write([record],fo,'fasta')
       prev_iter = curr_iter
       prev_pdb = pdb

#fo.close()
max_seqs = 1000

#take the last 1000 sequences only...keep 100 for testing...

for cpx in complex_dir.keys():
    #for seqrecord in complex_dir[cpx][:max_seqs]:
        #SeqIO.write([seqrecord],fo,'fasta')
          
    for seqrecord in complex_dir[cpx][-1000:-50]:    
        #test data
        SeqIO.write([seqrecord],fo,'fasta')

    for seqrecord in complex_dir[cpx][-50:]:
        SeqIO.write([seqrecord],ftest,'fasta')

fo.close() 
ftest.close()

